#include <iomanip.h>
#include <iostream.h>
#include <fstream.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#include <deffunc.h>

#include "SetCoverProblem.h"

/**
*/

SetCoverProblem::SetCoverProblem(ulong P1,ulong P2,ulong P3,ulong P4,double P5)
{   int i; 
    NumOfRows = P1 ;
    NumOfColumns =P2;
    NumberOfNonZeros =P3;
    TheBestIP =P4;
    TheBestLP =P5;

}// Constructor

/**
*/

SetCoverProblem::SetCoverProblem(const SetCoverProblem& RHS)
{    
    NumOfRows = RHS.NumOfRows ;
    NumOfColumns = RHS.NumOfColumns;
    NumberOfNonZeros = RHS.NumberOfNonZeros ;
    TheBestIP = RHS.TheBestIP;
    TheBestLP = RHS.TheBestLP;
    myColumns = RHS.myColumns;

}// COPY Constructor

/**
* Adds a new column to the Problem Set.
*/

void 
SetCoverProblem::UpdateRow(ulong ColumnNumber, ulong NumOfNZeros, 
                           ulong _profit, ulong col_rep, int *array)
{  
   Column *p1;
   int i;
   
   if(ColumnNumber>=0&&ColumnNumber<NumOfColumns)  
   {  
      p1 = new Column(NumOfRows);
      p1->setProfit(_profit);

      for(i=0;i<NumOfNZeros;i++) p1->set(array[i]);

      myColumns.addElement(p1);

      //cout << *myColumns[ColumnNumber]  << endl;

   }// end of if

}// end of UpdateRow() 

/**
*  Prints all the available Columns in the problem.
*/

void SetCoverProblem::printRowInfo(ostream& os) const
{  
   ulong i;
   Column **c;

   for(i=0;i<NumOfColumns;i++) 
   {
      c = myColumns.getElementAt(i);
      if(c!=NULL && *c!=NULL) os << **c << endl;

   }// end of if

}// end of printRowInfo()

/**
* Overloading output operator
*/

ostream& operator<<(ostream& os, const SetCoverProblem& RHS)
{  ulong i;

   RHS.printRowInfo(os);

   return os;

}// end of operator<<()

/**
*/

unsigned int SetCoverProblem::getNumOfRows() 
{ return (unsigned int)NumOfRows; }

/**
*/

unsigned int SetCoverProblem::getNumOfCols()
{ return (unsigned int)NumOfColumns; }

/**
*/

Column* SetCoverProblem::getColumnWithIndx(int idx)
{
   Column **c;

   c = myColumns.getElementAt(idx);

   return ( c!=NULL?*c:NULL);

}// end of getColumnWithIndx

/**
*/

SetCoverProblem::~SetCoverProblem()
{
   cout << "deallocate" << endl;

}// end of destructor

/*
// 
*/

void SetCoverProblem::sort()
{   
    /*
    ColumnPair *temp; 
    unsigned i,j;

    for(i=0;i<NumOfColumns;i++)
       for(j=i+1;j<NumOfColumns;j++)
	 if(myColumns[i]->getProfit()>myColumns[j]->getProfit())
	 {  temp = myColumns[j];
	    myColumns[j] = myColumns[i];
	    myColumns[i] = temp;
	 }
    */

}// end of sort

/*
// Returns -1 if the pattern does not exist.
*/

SetCoverProblem::getIndexOfSignature(char *pattern)
{  char *cover;
   int found = 0;
   unsigned i = 0;
   int j, equal;

   /*
   while( (!found) && i < NumOfColumns )
   {  
      cover = myColumns[i]->getID();

      equal=0;

      for(j=0;j<NumOfRows;j++) equal += ( cover[j] == pattern[j] );

      if( equal == NumOfRows ) found = 1;
      else i++;

      delete [] cover;

   }// end of while
   */

   return (found?i:-1);

}// end of getIndexOfSignature()

/*
// Returns -1 if the pattern does not exist.
*/

SetCoverProblem::getIndexOfParSignature(int exCol, char *pattern)
{  char *cover;
   int found = 0;
   unsigned i = 0;
   unsigned k = 0;
   int j, equal;
   int rand_seed = rand() % NumOfColumns;

   //cout << " I am looking for " << pattern << " except the col ";
   //cout << exCol << endl; 

   /*
   while( (!found) && k < NumOfColumns )
   {  
      i = (k+exCol+rand_seed)%NumOfColumns;

      cover = myColumns[i]->getID();

      equal=0;

      if(i!=exCol)
      {  for(j=0;j<NumOfRows;j++) 
	  if(pattern[j]!='#') equal += ( cover[j] == pattern[j] );
	  else equal++;
      }      

      if( equal == NumOfRows ) found = 1;

      k++;

      / *if(!found) 
      {  cout << setw(4) << i << " ";
	 for(j=0;j<NumOfRows;j++) cout << (cover[j]==1?'1':'0');
	 cout << " does not compatibles with " << endl;
	 cout << setw(4) << exCol << " ";
	 for(j=0;j<NumOfRows;j++) 
	    cout << (pattern[j]!='#'?(pattern[j]==1?'1':'0'):'#');
	 cout << endl;
      }* /

      delete [] cover;

   }// end of while
   */

   return (found?i:-1);

}// end of getIndexOfParSignature()

